#include "dbcon.h"
#include "common.h"
#define MAX_PATH 2048


void connect_db(MYSQL *conn) {

mysql_init(conn);

mysql_real_connect(conn,MYSQL_HOST,conf.mysql_id,conf.mysql_pw,conf.mysql_db,0,(char*)NULL,0);

printf("Connect DB!\n");


}

int user_check(MYSQL *conn,char *username) {
	//printf("start user_check()\n");
	MYSQL_RES *res;
	MYSQL_ROW row;
	char query_buf[512];
	memset(query_buf,0x0,sizeof(query_buf));

	snprintf(query_buf,512,"select user_id from msghard_user");
	//printf("%s\n",query_buf);	
	if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
	}
	
	res=mysql_store_result(conn);

	while((row = mysql_fetch_row(res))) {
		//printf("db : user_id : %s\n",row[0]);
		
		if(strcmp(row[0],username)==0) {
			/* ̵  return 1 */
	
		        mysql_free_result(res);

			return 1;
		}
	}
	//printf("free()\n");
	mysql_free_result(res);
	
	return 0;


}


void db_user_add(MYSQL *conn,char *username) {
	printf("start db_user_add\n");

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

	snprintf(query_buf,512,"insert into msghard_user values(\'%s\',sysdate(),sysdate(),%ld,%d,NULL,sysdate())",username,conf.default_size,0);

	if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
		printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
		error_handling("mysql error");
	}



}
void db_update_last_time(MYSQL *conn,char *username) {
	//printf("start db_update_last_time\n");

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        snprintf(query_buf,512,"update msghard_user set last_date=sysdate() where user_id=\'%s\'",username);

        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }

}
/*
void db_insert_file(MYSQL *conn,char *username) {
        //printf("start db_insert_file\n");

        char query_buf[512];
	char initial[50];
	memset(initial,0x0,50);
        memset(query_buf,0x0,sizeof(query_buf));
        strncpy(initial,file_queue[0].filename,50-3);
        initial[41]='.';
        initial[42]='.';
        initial[43]='\0';

	//printf("insert check1\n");
	//printf("%s\n",username);
	//printf("%s\n",file_queue[0].filename);
	//printf("%s\n",initial);
	//printf("%s\n",file_queue[0].path);

        snprintf(query_buf,512,"insert into msghard_file values(NULL,\'%s\',\'%s\',\'%s\',%ld,sysdate(),0,\'%s\',0)",username,file_queue[0].filename,initial,file_queue[0].filesize,file_queue[0].path);
	//printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }
	//printf("return db\n");
}


void db_insert_dir(MYSQL *conn,char *username,char *dirname,char *present_path) {
        printf("start db_insert_file\n");

        char query_buf[512];
        char initial[50];
        memset(initial,0x0,50);
        memset(query_buf,0x0,sizeof(query_buf));
        strncpy(initial,dirname,50-3);
        initial[41]='.';
        initial[42]='.';
        initial[43]='\0';

        //printf("insert check1\n");
        //printf("%s\n",username);
        //printf("%s\n",file_queue[0].filename);
        //printf("%s\n",initial);
        //printf("%s\n",file_queue[0].path);

        snprintf(query_buf,512,"insert into msghard_file values(NULL,\'%s\',\'%s\',\'%s\',%ld,sysdate(),1,\'%s\',0)",username,dirname,initial,0,present_path);
        //printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }
        //printf("return db\n");
}

void db_delete_dir_file(MYSQL *conn,char *username,char *filename,char *present_path) {
        printf("start db_delete_file\n");

        char query_buf[MAX_PATH];
        memset(query_buf,0x0,MAX_PATH);

        snprintf(query_buf,MAX_PATH,"delete from msghard_file where user_id=\'%s\' and locate=\'%s\'",username,present_path);

        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }

}
*/

void db_select_conf(MYSQL *conn,char *username,char *reg_date,int *is_pub,char *pub_name,long *total_size) {


        printf("start user_check()\n");
        MYSQL_RES *res;
        MYSQL_ROW row;
        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));
        printf("check\n");

        snprintf(query_buf,512,"select create_date , total_size,conf_pub ,conf_pubnm  from msghard_user where user_id=\'%s\'",user_id);
        //printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
        }

        res=mysql_store_result(conn);
	//printf("check1\n");

        while((row = mysql_fetch_row(res))) {
		//printf("user_id : %s\n",row[1]);	
		strncpy(reg_date,row[0],strlen(row[0]));
                *total_size = atol(row[1]);
                *is_pub = atoi(row[2]);
		if(row[3]==NULL) {
                        printf("haha\n");
                        strcpy(pub_name,"");
                }
		else {	
                	printf("hoho\n");
			strncpy(pub_name,row[3],strlen(row[3]));
		}

		//printf("%s\n",pub_name);

		//printf("recv_size : %d\n",*recv_size);
        }
        //printf("check2\n");

        mysql_free_result(res);

	//printf("ended db_conf\n");

}

void db_select_clubconf(MYSQL *conn,char *clubname,char *owner_id,char *create_date,int *is_admit) {
        printf("start user_check()\n");
        MYSQL_RES *res;
        MYSQL_ROW row;
        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));
        printf("check\n");

        snprintf(query_buf,512,"select owner_id,create_date,is_admit from msghard_club where club_name=\'%s\'",clubname);
        //printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
        }

        res=mysql_store_result(conn);
        //printf("check1\n");


        while((row = mysql_fetch_row(res))) {
                //printf("user_id : %s\n",row[1]);
		strncpy(owner_id,row[0],strlen(row[0]));
                strncpy(create_date,row[1],strlen(row[1]));
                *is_admit = atol(row[2]);
		
		mysql_free_result(res);
		return ;
        }
        //printf("check2\n");

        mysql_free_result(res);

        //printf("ended db_conf\n");



}


void db_update_pub_name(MYSQL *conn,char *username,char *pub_name) {
        //printf("start db_update_pub_name\n");

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        snprintf(query_buf,512,"update msghard_user set conf_pubnm=\'%s\' where user_id=\'%s\'",pub_name,username);

        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }

}

void db_update_conf_pub_1(MYSQL *conn,char *username) {
        printf("start db_update_setpub\n");

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        snprintf(query_buf,512,"update msghard_user set conf_pub=1 where user_id=\'%s\'",username);

        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
        }

	memset(query_buf,0x0,512);
        snprintf(query_buf,512,"update msghard_user set conf_pub_date=sysdate() where user_id=\'%s\'",username);

        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
        }


}
void db_update_conf_pub_0(MYSQL *conn,char *username) {
        printf("start db_update_setpub\n");

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        snprintf(query_buf,512,"update msghard_user set conf_pub=0 where user_id=\'%s\'",username);

        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
        }

}
void db_update_clubconf_is_admit_0(MYSQL *conn,char *clubname) {

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        snprintf(query_buf,512,"update msghard_club set is_admit=0 where club_name=\'%s\'",clubname);

        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
        }


}


void db_update_clubconf_is_admit_1(MYSQL *conn,char *clubname) {

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        snprintf(query_buf,512,"update msghard_club set is_admit=1 where club_name=\'%s\'",clubname);

        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
        }


}









void db_select_get_myclublist(MYSQL *conn,char *username,club_list *clublist_head,int *clublist_max_count) {

	*clublist_max_count=0;
        club_list *p=NULL;
        //printf("start db_select_get_myclublist\n");
        MYSQL_RES *res;
        MYSQL_ROW row;
	MYSQL_RES *sub_res;
	MYSQL_ROW sub_row;

        char query_buf[512];
	char sub_query_buf[512];

        memset(query_buf,0x0,sizeof(query_buf));
        printf("check\n");

        snprintf(query_buf,512,"select club_name from msghard_club_user where user_id=\'%s\' order by reg_date desc",username);


        //printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }

        res=mysql_store_result(conn);
        //printf("check1\n");
        p=clublist_head;


        while((row = mysql_fetch_row(res))) {
                //printf("::getclublist while\n");
                club_list *node = (club_list*)malloc(sizeof(club_list));
		memset(sub_query_buf,0x0,512);

		snprintf(sub_query_buf,512,"select a.owner_id, a.club_name, a.total_size,count(*) as user_count from msghard_club a join msghard_club_user b on a.club_name=b.club_name where a.club_name=\'%s\' group by b.club_name order by b.reg_date desc",row[0]);
                //printf("node2\n");

        	//printf("%s\n",sub_query_buf);
        	if(mysql_real_query(conn,sub_query_buf,strlen(sub_query_buf))!=0) {
                	printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
        	        error_handling("mysql error");
	        }

	        sub_res=mysql_store_result(conn);
		sub_row = mysql_fetch_row(sub_res);

                memset(node,0x0,sizeof(club_list));

               // printf("user_id : %s \n",row[0]);
                memset(node->data.clubname,0x0,255);

                strncpy(node->data.ownername,sub_row[0],strlen(sub_row[0]));
                strncpy(node->data.clubname,sub_row[1],strlen(sub_row[1]));
                node->data.totalsize = atol(sub_row[2]);
                node->data.count = *clublist_max_count +1;
                node->data.usercount=atoi(sub_row[3]);

                (*clublist_max_count)++;

                memset(query_buf,0x0,512);
/*
		printf("node->clubname : %s\n",node->data.clubname);
                printf("node->ownername : %s\n",node->data.ownername);
                printf("node->usercount : %d\n",node->data.usercount);
		printf("node->totalsize : %ld\n",node->data.totalsize);
*/
                p->Next = node;

  //              printf("clublist_max_count : %d\n",*clublist_max_count);
                p=p->Next;
		mysql_free_result(sub_res);
    //            printf("check\n");
        }
	//memset(row,0x0,sizeof(row));
        mysql_free_result(res);

        printf("ended db_get_myclublist\n");

}

void db_select_get_allclublist(MYSQL *conn,char *username,club_list *clublist_head,int *clublist_max_count,int type) {
	// type : Ÿ
 // αŬ
 // ֽŬ
 // üŬ
        *clublist_max_count=0;
        club_list *p=NULL;
        printf("start db_select_get_allclublist\n");
        MYSQL_RES *res=NULL;
        MYSQL_ROW row=NULL;

        char query_buf[512];
        memset(query_buf,0x0,512);
        printf("check\n");


        if(type==1) {
                // 
	        snprintf(query_buf,512,"select a.owner_id, a.club_name, a.total_size,count(*) as user_count from msghard_club a join msghard_club_user b on a.club_name=b.club_name group by b.club_name order by user_count desc");
        }
        else if(type==2) {
                //¥ 
        snprintf(query_buf,512,"select a.owner_id, a.club_name, a.total_size,count(*) as user_count from msghard_club a join msghard_club_user b on a.club_name=b.club_name group by b.club_name order by a.create_date desc");
        }
        else if(type==3) {
                snprintf(query_buf,512,"select a.owner_id, a.club_name, a.total_size,count(*) as user_count from msghard_club a join msghard_club_user b on a.club_name=b.club_name group by b.club_name");
        }


        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }

        res=mysql_store_result(conn);
       // printf("check1\n");
        p=clublist_head;
        while((row = mysql_fetch_row(res))) {
                //printf("::get_allclublist while\n");
                club_list *node = (club_list*)malloc(sizeof(club_list));
	//	printf("node2\n");
                memset(node,0x0,sizeof(club_list));

     //           printf("user_id : %s \n",row[0]);
                memset(node->data.clubname,0x0,255);


                strncpy(node->data.ownername,row[0],strlen(row[0]));
                strncpy(node->data.clubname,row[1],strlen(row[1]));
                node->data.totalsize = atol(row[2]);
                node->data.count = *clublist_max_count +1;
                node->data.usercount=atoi(row[3]);

                (*clublist_max_count)++;

                memset(query_buf,0x0,512);


                p->Next = node;

  //              printf("clublist_max_count : %d\n",*clublist_max_count);
                p=p->Next;
   //             printf("check\n");


        }	
	//memset(row,0x0,sizeof(row));

        mysql_free_result(res);

        printf("ended db_get_allclublist\n");

}



void db_select_get_waituserlist(MYSQL *conn,user_list *userlist_head,char *clubname,int *userlist_max_count) {
        *userlist_max_count=0;
        user_list *p=NULL;
        MYSQL_RES *res;
        MYSQL_ROW row;
        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));
        snprintf(query_buf,512,"select user_id from msghard_club_user where club_name=\'%s\' and club_perm=2 order by reg_date desc",clubname);
        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
        }

        res=mysql_store_result(conn);
        p=userlist_head;
	userlist_head->Next=NULL;
        while((row = mysql_fetch_row(res))) {
                printf("while\n");
                user_list *node = (user_list*)malloc(sizeof(user_list));
		node->Next=NULL;
                memset(node,0x0,sizeof(user_list));

                memset(node->data.username,0x0,256);

                strncpy(node->data.username , row[0] , strlen(row[0]));
                node->data.count = *userlist_max_count +1;
                p->Next = node;
                (*userlist_max_count)++;
                p=p->Next;
        }
        printf("end db_select_get_alluserlist\n");
        mysql_free_result(res);
}


void db_select_get_alluserlist(MYSQL *conn,user_list *userlist_head,char *clubname,int *userlist_max_count) {
        *userlist_max_count=0;
        user_list *p=NULL;
        MYSQL_RES *res;
        MYSQL_ROW row;
        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));
        snprintf(query_buf,512,"select user_id from msghard_club_user where club_name=\'%s\' and club_perm<>0 order by reg_date desc",clubname);
        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
        }

        res=mysql_store_result(conn);
        p=userlist_head;
	userlist_head->Next=NULL;
        while((row = mysql_fetch_row(res))) {
                printf("while\n");
                user_list *node = (user_list*)malloc(sizeof(user_list));
		node->Next=NULL;
                memset(node,0x0,sizeof(user_list));

                memset(node->data.username,0x0,256);

                strncpy(node->data.username , row[0] , strlen(row[0]));
                node->data.count = *userlist_max_count +1;
                p->Next = node;
                (*userlist_max_count)++;
                p=p->Next;
        }
	printf("end db_select_get_alluserlist\n");
        mysql_free_result(res);
}







void db_select_get_publist(MYSQL *conn,char *username,pub_list *publist_head,int *publist_max_count) {


	*publist_max_count=0;
	pub_list *p=NULL;
        printf("start db_select_get_publist\n");
        MYSQL_RES *res;
        MYSQL_ROW row;
        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));
        printf("check\n");

        snprintf(query_buf,512,"select user_id,conf_pubnm from msghard_user where conf_pub=1 order by conf_pub_date desc");
        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
        }

        res=mysql_store_result(conn);
        printf("check1\n");
	p=publist_head;
        while((row = mysql_fetch_row(res))) {
		printf("while\n");
		pub_list *node = (pub_list*)malloc(sizeof(pub_list));

		memset(node,0x0,sizeof(pub_list));
				
                printf("user_id : %s , subject : %s\n",row[0],row[1]);
		memset(node->data.username,0x0,256);

		strncpy(node->data.username , row[0] , strlen(row[0]));
		node->data.count = *publist_max_count +1;
		if(row[1] == NULL) {
			strcpy(node->data.subject,"");
		}
		else {
			strncpy(node->data.subject,row[1],strlen(row[1]));
		}
		p->Next = node;
		(*publist_max_count)++;



		printf("publist_max_count : %d\n",*publist_max_count);
		p=p->Next;
		printf("check\n");
        }

        mysql_free_result(res);

        printf("ended db_get_publist\n");

}
int db_check_clubname(MYSQL *conn,char *username,char *clubname) {

        MYSQL_RES *res;
        MYSQL_ROW row;
        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        snprintf(query_buf,512,"select club_name from msghard_club");
        //printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
        }

        res=mysql_store_result(conn);

        while((row = mysql_fetch_row(res))) {
                //printf("db : user_id : %s\n",row[0]);

                if(strcmp(row[0],clubname)==0) {

                        /* ̵  return 1 */
		        mysql_free_result(res);

                        return 1;
                }
        }
        //printf("free()\n");
        mysql_free_result(res);

        return 0;

}

void db_insert_club(MYSQL *conn,char *username,char *clubname,int is_admit) {
        printf("start db_insert_club\n");

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        //printf("insert check1\n");
        //printf("%s\n",username);
        //printf("%s\n",file_queue[0].filename);
        //printf("%s\n",initial);
        //printf("%s\n",file_queue[0].path);

        snprintf(query_buf,512,"insert into msghard_club values(\'%s\',sysdate(),\'%s\',%ld,%d)",username,clubname,conf.default_clubsize,is_admit);
        //printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }
        //printf("return db\n");
}



void db_insert_club_join_user(MYSQL *conn,char *username,char *clubname,int club_perm) {
        printf("start db_insert_club_join_user\n");

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        //printf("insert check1\n");
        //printf("%s\n",username);
        //printf("%s\n",file_queue[0].filename);
        //printf("%s\n",initial);
        //printf("%s\n",file_queue[0].path);

        snprintf(query_buf,512,"insert into msghard_club_user values(\'%s\',\'%s\',sysdate(),%d)",clubname,username,club_perm);
        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }
        //printf("return db\n");
}



int db_select_count_clublist(MYSQL *conn) {

        printf("start db_select_count_clublist\n");
	int count=0;
        char query_buf[512];

        MYSQL_RES *res;
        MYSQL_ROW row;

        memset(query_buf,0x0,sizeof(query_buf));

        //printf("insert check1\n");
        //printf("%s\n",username);
        //printf("%s\n",file_queue[0].filename);
        //printf("%s\n",initial);
        //printf("%s\n",file_queue[0].path);

        snprintf(query_buf,512,"select count(*) from msghard_club");
        //printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }
        //printf("return db\n");
        res=mysql_store_result(conn);

        row = mysql_fetch_row(res);

	count = atoi(row[0]);

        mysql_free_result(res);

        return count;


}
int db_select_check_club_perm(MYSQL *conn,char *user_id,char *use_clubname) {
	printf("start db_select_check_club_perm()\n");
        MYSQL_RES *res;
        MYSQL_ROW row;
        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        snprintf(query_buf,512,"select club_perm from msghard_club_user where club_name=\'%s\' and user_id=\'%s\'",use_clubname,user_id);
        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
        }

        res=mysql_store_result(conn);

        while((row = mysql_fetch_row(res))) {
                printf("club_perm %s\n",row[0]);


                mysql_free_result(res);

                return atoi(row[0]);
        }
        //printf("free()\n");
        mysql_free_result(res);

        return 3;

}
int db_select_check_is_admit(MYSQL *conn,char *use_clubname) {
        printf("start db_select_check_join_club_perm()\n");
	// ŬԽ ð , ΰ  üũ
	// is_admit ::  0 : ð  , 1 : ΰ
        MYSQL_RES *res;
        MYSQL_ROW row;
        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        snprintf(query_buf,512,"select is_admit from msghard_club where club_name=\'%s\'",use_clubname);
        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
        }

        res=mysql_store_result(conn);

        while((row = mysql_fetch_row(res))) {
                printf("club_perm %s\n",row[0]);


                mysql_free_result(res);

                return atoi(row[0]);
        }
        //printf("free()\n");
        mysql_free_result(res);

        return 3;

}
void db_delete_club(MYSQL *conn,char *user_id,char *clubname) {
        printf("start db_delete_club__user\n");

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));


        snprintf(query_buf,512,"delete from msghard_club where club_name=\'%s\'",clubname);
        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }


        memset(query_buf,0x0,sizeof(query_buf));


        snprintf(query_buf,512,"delete from msghard_club_user where club_name=\'%s\'",clubname);
        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }




}


void db_delete_club_user(MYSQL *conn,char *username,char *clubname) {
        printf("start db_delete_club__user\n");

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));


        snprintf(query_buf,512,"delete from msghard_club_user where club_name=\'%s\' and user_id=\'%s\'",clubname,username);
        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }
        //printf("return db\n");
	

}
void db_update_allow_club_user(MYSQL *conn,char *username,char *clubname) {
        printf("start db_delete_club__user\n");

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));


        snprintf(query_buf,512,"update msghard_club_user set club_perm=1 where club_name=\'%s\' and user_id=\'%s\'",clubname,username);
        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }
        //printf("return db\n");


}

int db_select_total_size(MYSQL *conn,char *username) {
        MYSQL_RES *res;
        MYSQL_ROW row;
        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        snprintf(query_buf,512,"select total_size from msghard_user where user_id=\'%s\'",username);
        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }

        res=mysql_store_result(conn);

        while((row = mysql_fetch_row(res))) {

                mysql_free_result(res);

                return atoi(row[0]);
        }
        //printf("free()\n");
        mysql_free_result(res);

        return 100;



}
int db_select_club_total_size(MYSQL *conn,char *clubname) {
        MYSQL_RES *res;
        MYSQL_ROW row;
        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        snprintf(query_buf,512,"select total_size from msghard_club where club_name=\'%s\'",clubname);
        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }

        res=mysql_store_result(conn);

        while((row = mysql_fetch_row(res))) {
		
                mysql_free_result(res);

                return atoi(row[0]);
        }
        //printf("free()\n");
        mysql_free_result(res);
	printf("ƹ \n");
        return 10000;



}

